searchData={"items":[{"type":"module","title":"GuardianRedis.Adapter","doc":"An adapter for `Guardian.DB` that uses Redis.\n\nServes only `Guardian.DB` purpose, do not use it as a Redis adapter for your project.\n\nDependant on `Jason` and `Redix`.\n\nStores and deletes JWT token to/from Redis using key combined from JWT.jti and JWT.aud.\n\nModule stores JWT token in Redis using automatic expiry feature of Redis so we don't need to run token sweeper.","ref":"GuardianRedis.Adapter.html"},{"type":"function","title":"GuardianRedis.Adapter.delete/2","doc":"Remove a user token, log out functionality, invalidation of a JWT token.","ref":"GuardianRedis.Adapter.html#delete/2"},{"type":"function","title":"GuardianRedis.Adapter.delete_by_sub/2","doc":"Remove all tokens that belong to given `sub`.","ref":"GuardianRedis.Adapter.html#delete_by_sub/2"},{"type":"function","title":"GuardianRedis.Adapter.insert/2","doc":"Insert Token into Redis.\n\nToken is auto expired in `expired_in` seconds based on JWT `exp` value.","ref":"GuardianRedis.Adapter.html#insert/2"},{"type":"function","title":"GuardianRedis.Adapter.one/2","doc":"Fetches a single result from the query.\n\nReturns nil if no result was found. Raises if more than one entry.","ref":"GuardianRedis.Adapter.html#one/2"},{"type":"function","title":"GuardianRedis.Adapter.purge_expired_tokens/2","doc":"Mock implementation as Redis has built in key expiration that is in use.","ref":"GuardianRedis.Adapter.html#purge_expired_tokens/2"},{"type":"module","title":"GuardianRedis.Redix","doc":"Redix module.\n\n#","ref":"GuardianRedis.Redix.html"},{"type":"module","title":"Configuration - GuardianRedis.Redix","doc":"Configuration options are the same as in `Redix.start_link/1`, except for\n`pool_size`, `name_prefix`, and `name`.\n\n- `pool_size` - determines how many Redix connections are created; defaults to `1`\n- `name_prefix` - the prefix used in `name`; defaults to `\"guardian_redis\"`\n\nThe `name` option is overwritten based on the given `name_prefix` and `pool_size`.\nIn the case of the example below, `name` would be `:g_redis_0` for the first\nRedis connection, and `:g_redis_1` for the second.\n\n```\nconfig :guardian_redis, :redis,\n  host: \"127.0.0.1\",\n  port: 6379,\n  pool_size: 2,\n  name_prefix: \"g_redis\"\n```","ref":"GuardianRedis.Redix.html#module-configuration"},{"type":"function","title":"GuardianRedis.Redix.child_spec/1","doc":"Specs for the Redix connections.","ref":"GuardianRedis.Redix.html#child_spec/1"},{"type":"function","title":"GuardianRedis.Redix.command/1","doc":"Redis commands execution via pool of Redix workers\ncommand_params - List of String commands, e.g. [\"GET\", \"redis_key\"]","ref":"GuardianRedis.Redix.html#command/1"},{"type":"function","title":"Examples - GuardianRedis.Redix.command/1","doc":"iex> GuardianRedis.Redix.command([\"SET\", \"key\", \"value\"])\n    {:ok, \"OK\"}\n    iex> GuardianRedis.Redix.command([\"GET\", \"key\"])\n    {:ok, \"value\"}","ref":"GuardianRedis.Redix.html#command/1-examples"},{"type":"extras","title":"GuardianRedis","doc":"# GuardianRedis\n\n[![Hex.pm](https://img.shields.io/hexpm/v/guardian_redis.svg)](https://hex.pm/packages/guardian_redis)\n![Build Status](https://github.com/alexfilatov/guardian_redis/workflows/Continuous%20Integration/badge.svg)\n\nRedis adapter for Guardian DB.","ref":"readme.html"},{"type":"extras","title":"Installation - GuardianRedis","doc":"You can use `GuardianRedis` in case you use [Guardian](https://github.com/ueberauth/guardian) library for authentication\nand [Guardian.DB](https://github.com/ueberauth/guardian_db) library for JWT tokens persistence.\n\nIf [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `guardian_redis` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:guardian_redis, \"~> 0.2.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - GuardianRedis","doc":"All you need to install Guardian DB as per [Guardian.DB README](https://github.com/ueberauth/guardian_db#readme)\nand just use `GuardianRedis.Adapter` as a `adapter` in settings.\n\n```elixir\nconfig :guardian, Guardian.DB,\n       adapter: GuardianRedis.Adapter # Add this Redis adapter module\n```\n\nAdd GuardianRedis.Redix to your supervision tree:\n\n(Note: If this is not configured you will get a `no process` error when storing or revoking tokens!)\n\n```elixir\ndefmodule MyApp.Application do\n\n  # ...\n\n  defp my_app_otp_apps() do\n    children = [\n      MyApp.Repo,\n      GuardianRedis.Redix\n    ]\n  end\nend\n```\n\nApart from this please set up Redis configuration:\n\n```elixir\nconfig :guardian_redis, :redis,\n  host: \"127.0.0.1\",\n  port: 6379,\n  pool_size: 10\n```\n\nMore options are available as described in `GuardianRedis.Redix`.","ref":"readme.html#configuration"},{"type":"extras","title":"Implement Guardian.DB adapter for a different storage - GuardianRedis","doc":"Initially, Guardian.DB was aimed to store and operate JWT tokens in a PostgreSQL database.\nSometimes round trip to Postgres database is expensive so this is why this Redis adapter was born.\nIn case you want to implement a possibility for Guardian.DB to use different storage, e.g. ETS (or MySQL),\nyou need to implement `Guardian.DB.Adapter` behavior. Thanks to [@aleDsz](https://github.com/aleDsz) it's quite simple:\nhttps://github.com/ueberauth/guardian_db/blob/master/lib/guardian/db/adapter.ex\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at [https://hexdocs.pm/guardian_redis](https://hexdocs.pm/guardian_redis).","ref":"readme.html#implement-guardian-db-adapter-for-a-different-storage"}],"content_type":"text/markdown"}